## radare 1.4

=== wscript ===
#! /usr/bin/env python

import os
import os.path
import shutil
import Options

VERSION='1.3'
APPNAME='radare'

srcdir = '.'
blddir = 'build'
prefix = '/usr'

def set_options(opt):
	opt.tool_options('compiler_cc')
	opt.tool_options('compiler_cxx')
	opt.add_option('--with-maemo',       action='store_true',  default=False, help='Build for maemo',          dest='MAEMO')
	opt.add_option('--with-sysproxy',    action='store_true',  default=False, help='Build with syscall proxy', dest='SYSPROXY')
	opt.add_option('--without-gui',      action='store_false', default=True,  help='Build without GUI',        dest='GUI')
	opt.add_option('--without-debugger', action='store_false', default=True,  help='Build without debugger',   dest='DEBUGGER')
	opt.add_option('--without-readline', action='store_false', default=True,  help='Build without readline',   dest='HAVE_READLINE')
	opt.add_option('--without-lua',      action='store_false', default=True,  help='Build without LUA',        dest='HAVE_LIBLUA')
	opt.add_option('--without-python',   action='store_false', default=True,  help='Build without Python',     dest='HAVE_PYTHON')
	opt.add_option('--without-ruby',     action='store_false', default=True,  help='Build without Ruby',       dest='HAVE_RUBY')
	opt.add_option('--prefix',
		help    = "installation prefix [Default: '%s']" % prefix,
		default = prefix,
		dest    = 'PREFIX')

def configure(conf):
	# Check for compiler tools
	conf.check_tool('compiler_cc')
	try: conf.check_tool('compiler_cxx')
	except: pass
	have_valac = False
	try:
		conf.check_tool('vala')
		have_valac = True
	except: pass
	try: conf.check_tool('perl')
	except: pass
	try: conf.check_tool('lua')
	except: pass
	if not conf.env['CC']: fatal('C compiler not found')

	# Check libraries
        conf.check_pkg('glib-2.0', destvar='GLIB', vnum='2.10.0', mandatory=False)
        conf.check_pkg('gtk+-2.0', destvar='GTK', vnum='2.10.0', mandatory=False)
        conf.check_pkg('vte',      destvar='VTE', vnum='0.16', mandatory=False)
	conf.checkEndian()

	if Options.options.HAVE_PYTHON == True:
		try:
			conf.check_tool('python')
			conf.check_python_version((2,4,2));
			conf.check_python_headers()
			conf.env['HAVE_PYTHON']=1 # XXX
		except: 
			print " ==> Use --without-python"
			conf.env['HAVE_PYTHON']=0
		pass
	else:
		conf.env['HAVE_PYTHON']=0

	if Options.options.MAEMO == True:
        	conf.check_pkg('hildon-1',      destvar='HILDON', vnum='0.1', mandatory=False)

	# Generate GLOBAL.H
	conf.env['GUI'] = False
	# Vala is no longer required for building the GUI
	if conf.env['HAVE_GTK'] == 1 and conf.env['HAVE_VTE'] == 1 and Options.options.GUI:
		conf.env['GUI'] = True
	# if conf.env['HAVE_GTK'] == 1 and conf.env['HAVE_VTE'] == 1 and have_valac and Options.options.GUI:
	#	conf.env['GUI'] = True
	conf.env['OS'] = os.uname()[0]
	conf.env['CPU'] = os.uname()[4]
	if conf.env['CPU'] == 'Power Macintosh': conf.env['CPU'] = 'powerpc' # osx
	if conf.env['CPU'] == 'ppc': conf.env['CPU'] = 'powerpc' # linux
	if conf.env['CPU'] == 'i86pc': conf.env['CPU'] = 'i386'
	if conf.env['CPU'] == 'i686': conf.env['CPU'] = 'i386'
	if conf.env['CPU'] == 'i586': conf.env['CPU'] = 'i386'
	if conf.env['CPU'] != 'arm' and conf.env['CPU'] != 'powerpc' and conf.env['CPU'] != 'i386' and conf.env['CPU'] != 'powerpc' and conf.env['CPU'] != 'x86_64' and conf.env['CPU'] != 'mips64':
		print "Unknown CPU. Disabling debugger"
		Options.options.DEBUGGER = False

	conf.define('True', 1)
	conf.define('False', 0) # hack for booleans
	conf.define('VERSION', VERSION)
	conf.define('W32', False)
	conf.define('SIZE_OFF_T', 8)
	conf.define('DARWIN', False)
	conf.define('DEBUGGER', Options.options.DEBUGGER)
	conf.define('SYSPROXY', Options.options.SYSPROXY)
	conf.define('_MAEMO_', Options.options.MAEMO)
	conf.define('CPU', conf.env['CPU'])
	conf.define('OS', conf.env['OS'])
	conf.define('TARGET', "%s-%s"%(conf.env['CPU'],conf.env['OS']))

	conf.define('HAVE_VALAC', conf.env['GUI'])
	#conf.define('HAVE_GTK', conf.env['HAVE_GTK'])
	conf.define('HAVE_LANG_LUA', False)
	endian = True
	try:
		if conf.env['IS_BIGENDIAN'] == 1:
			endian = False
	except x:
		endian = True
	conf.define('LIL_ENDIAN', endian)
	conf.define('HAVE_LANG_PYTHON', False)
	conf.define('PREFIX',  Options.options.PREFIX)
	conf.define('LIBDIR',  "%s/lib"%Options.options.PREFIX)
	conf.define('SHAREDIR', "%s/share/"%Options.options.PREFIX)
	conf.define('DOCDIR',  "%s/share/doc/radare"%Options.options.PREFIX)
	conf.define('GRSCDIR', "%s/share/radare/gradare"%Options.options.PREFIX)
	#conf.define('LIBEXECDIR', '/usr/share/doc/radare') # DEPRECATED

	# Check for ruby
	print "Checking for ruby mkmf\t\t\t    :",
	if os.system("ruby src/plug/hack/chkruby.rb") == 0:
		print "ok"
	else:
		print "not found"
		Options.options.HAVE_RUBY = False
	conf.define('HAVE_RUBY', Options.options.HAVE_RUBY)

	# Check for libreadline
	rl = conf.create_library_configurator()
	rl.name = 'readline'
	rl.define = 'HAVE_READLINE'
	rl.libs = ['readline']
	rl.mandatory = False
	rl.run()
	if conf.env['HAVE_READLINE'] != 1:
		Options.options.HAVE_READLINE = False
	conf.define('HAVE_LIB_READLINE', Options.options.HAVE_READLINE)

	# Check for liblua
	rl = conf.create_library_configurator()
	rl.name = 'lua'
	rl.define = 'HAVE_LIBLUA'
	rl.libs = ['lua']
	rl.mandatory = False
	rl.run()
	if conf.env['HAVE_LIBLUA'] != 1:
		rl2 = conf.create_library_configurator()
		rl2.name = 'lua5.1'
		rl2.define = 'HAVE_LIBLUA51'
		rl2.libs = ['lua5.1']
		rl2.mandatory = False
		rl2.run()
		if conf.env['HAVE_LIBLUA51'] != 1:
			Options.options.HAVE_LIBLUA = False
		else:
			conf.env['HAVE_LIBLUA_LD'] = "-llua5.1"
			conf.env['HAVE_LIBLUA_CC'] = "-I /usr/include/lua5.1"
	else:
		conf.env['HAVE_LIBLUA_LD'] = "-llua"
	conf.define('HAVE_LIBLUA', Options.options.HAVE_LIBLUA)
	conf.define('HAVE_GUI', conf.env['GUI'])

	rl2 = conf.create_library_configurator()
	rl2.name = 'dl'
	rl2.libs = ['dl']
	rl2.mandatory = False
	rl2.run()

	rl2 = conf.create_library_configurator()
	rl2.name = 'ewf'
	rl2.libs = ['ewf']
	rl2.mandatory = False
	rl2.run()
	if conf.env['HAVE_EWF'] != 1:
		conf.env['HAVE_EWF'] = False
	conf.define('HAVE_LIB_EWF', conf.env['HAVE_EWF'])

	# Write global.h and show report to stdout
	conf.write_config_header('global.h')
	shutil.copyfile("%s/default/global.h"%blddir, "%s/global.h"%srcdir)
	
	print " * Prefix    : %s"%conf.env['PREFIX']
	#print " * InstDir   : %s"%inst_var
	print " * Target    : %s"%conf.env['TARGET']
	print " * LilEndian : %s"%conf.env['LIL_ENDIAN']
	print " * HaveRuby  : %s"%conf.env['HAVE_RUBY']

	if conf.env['HAVE_LIB_EWF'] == 1:
		print " * EWF       : enabled"
	else:
		print " * EWF       : disabled"

	if Options.options.DEBUGGER:
		print " * Debugger  : enabled"
	else:
		print " * Debugger  : disabled"

	if Options.options.HAVE_READLINE:
		print " * Readline  : enabled"
	else:
		print " * Readline  : disabled"

	if Options.options.SYSPROXY:
		print " * SysProxy  : enabled"
	else:
		print " * SysProxy  : disabled"

	if conf.env['GUI'] == 1:
		print " * GUI       : enabled"
	else:
		print " * GUI       : disabled"
	print "Use --without-gui : vala-waf support is not yet complete"

def build(bld):
	#shutil.copyfile(srcdir+"/src/utils.c", srcdir+"/src/ut.c")
	if bld.env['GUI']:
		bld.add_subdirs('vala')
	bld.add_subdirs('src')
	#if Params.g_commands['clean']:
	#	os.system("echo unknown clean")

	bld.install_files('${PREFIX}/lib/python2.5', 'src/plug/hack/radare.py')
	bld.install_files('${PREFIX}/lib/python2.6', 'src/plug/hack/radare.py')
	bld.install_files('${PREFIX}/lib/radare', 'src/plug/hack/radare.lua')
	bld.install_files('${PREFIX}/lib/radare', 'src/plug/hack/radare.rb')
	# RSC scripts
	#if bld.env['HAVE_RUBY'] == 1:
	try:
		if os.path.exists('src/plug/hack/ruby.so'):
			bld.install_files('${PREFIX}/lib/radare', 'src/plug/hack/ruby.so', chmod=0755)
	except:
		print "WTF with ruby!!"
	bld.install_files('${PREFIX}/lib/radare/bin', 'src/rsc/pool/*', chmod=0755)
	bld.install_files('${PREFIX}/lib/radare/bin', 'src/radiff/bindiff-ng/bindiff-ng', chmod=0755)
	bld.install_files('${PREFIX}/lib/radare/bin', 'src/javasm/javasm', chmod=0755)
	if bld.env['OS'] == 'Darwin' : bld.install_files('${PREFIX}/lib/radare/bin', 'src/arch/arm/aasm/armasm', chmod=0755)
	bld.install_files('${PREFIX}/lib/radare/bin', 'src/lsbstego', chmod=0755)
	# Documentation
	bld.install_files('${PREFIX}/share/man/man1', 'man/*.1')
	bld.install_files('${PREFIX}/share/man/man5', 'man/*.5')
	bld.install_files('${PREFIX}/share/doc/radare', 'README')
	bld.install_files('${PREFIX}/share/doc/radare', 'COPYING')
	bld.install_files('${PREFIX}/share/doc/radare', 'AUTHORS')
	bld.install_files('${PREFIX}/share/doc/radare', 'HISTORY')
	bld.install_files('${PREFIX}/share/doc/radare', 'TODO')
	bld.install_files('${PREFIX}/share/doc/radare', 'doc/csr')
	bld.install_files('${PREFIX}/share/doc/radare', 'doc/flags')
	bld.install_files('${PREFIX}/share/doc/radare', 'doc/fortunes')
	bld.install_files('${PREFIX}/share/doc/radare', 'doc/gdb.scripts')
	bld.install_files('${PREFIX}/share/doc/radare', 'doc/map-struct')
	bld.install_files('${PREFIX}/share/doc/radare', 'doc/shell')
	bld.install_files('${PREFIX}/share/doc/radare/xtra', 'doc/xtra/*')
	bld.install_files('${PREFIX}/share/doc/radare/', 'src/radiff/ida2rdb.idc')
	if bld.env['GUI']:
		bld.install_files('${PREFIX}/share/radare/gradare', 'gui/grsc/Shell', chmod=0755)
		for dir in "Config Debugger Disassembly Flags Hacks Movement Search Visual".split(" "):
			bld.install_files('${PREFIX}/share/radare/gradare/%s'%dir, 'gui/grsc/%s/*'%dir, chmod=0755)

def install():
	print "Installing..."


def shutdown():
	pass

#        # display the graph of header dependencies
##       if 1: return
#        import Params, os, types
#
#        f = open('foo.dot', 'w')
#        f.write("digraph G {\n")
#        table = Params.g_build.node_deps
#        for a in table:
#                for x in table[a]:
#                        if type(table[a][x]) is types.ListType:
#                                for y in table[a][x]:
#                                        f.write('"%s" -> "%s";\n' % (x, y))
#                        else:
#                                f.write('"%s" -> "%s";\n' % (x, table[a][x]))
#        f.write('}\n')
#        f.close()
#

=== doc/Makefile ===
all:
	halibut --pdf=radare.pdf radare.but
	halibut --text=radare.pdf.txt radare.but > /dev/null 2>&1
	halibut --html=radare.pdf.html radare.but
	mkdir -p html && cd html && halibut --html ../radare.but

push:
	scp radare.pdf radare.pdf.html news.nopcode.org:/home/www/radarenopcode/get
	rsync -avz html/* news.nopcode.org:/home/www/radarenopcode/doc/html

=== gui/Makefile ===
include ../config.mk

BIN=gradare${BINSFX}
OBJ=main.o topbar.o toolbar.o actions.o execute.o prefs.o menubar.o dialog.o
CFLAGS+=-DPREFIX=\"${PREFIX}\" -DGRSCDIR=\"${DATADIR}/radare/gradare\"
CFLAGS+=${GTK_FLAGS} ${VTE_FLAGS}
#`pkg-config glib-2.0 gtk+-2.0 vte --cflags`
LIBS+=${GTK_LIBS} ${VTE_LIBS}
CFLAGS+=-D_MAEMO_=${MAEMO}
#`pkg-config glib-2.0 gtk+-2.0 vte --libs`
# MAEMO STUFF
ifeq ($(MAEMO),1)
CFLAGS+=`pkg-config --cflags hildon-1`
LIBS+=`pkg-config --libs hildon-1`
endif


all: ${BIN}
	${E} 'Linking ${BIN}'

${BIN}: ${OBJ}
	${Q}${CC} ${CFLAGS} ${LDFLAGS} ${OBJ} ${LIBS} -o ${BIN}

${OBJ}: %.o: %.c
	${E} 'Compiling $<'
	${Q}${CC} ${CFLAGS} -c -o $@ $<

install:
	${E} 'Installing gradare'
	${Q}${INSTALL_DIR} ${DESTDIR}/${PREFIX}/bin
	-${Q}${INSTALL_PROGRAM} ${BIN} ${DESTDIR}/${PREFIX}/bin
	-${Q}rm -rf ${DESTDIR}/${DATADIR}/radare/gradare/*
	${Q}mkdir -p ${DESTDIR}/${DATADIR}/radare/gradare/
	${Q}cp -rf grsc/* ${DESTDIR}/${DATADIR}/radare/gradare/
	-${Q}chmod +x ${DESTDIR}/${DATADIR}/radare/gradare/Shell

clean:
	${E} 'Cleaning gui'
	-${Q}rm -f ${OBJ} ${BIN}

=== java/Makefile ===
include ../config.mk

all:
	${E} 'Compiling java code'
	${Q}${JAVAC} org/nopcode/pancake/radare/*.java
	${Q}${JAVAC} org/nopcode/pancake/radare/data/*.java
	${Q}${JAVAC} org/nopcode/pancake/radare/demos/*.java
	${Q}${JAVAC} org/nopcode/pancake/radare/swing/*.java

jar:
	if [ ! -e org/nopcode/pancake/radare/Radare.class ]; then\
		echo "Java api not compiled.";\
		exit 1;\
	fi
	jar cmf ./META-INF/MANIFEST.MF ./radare.jar `find org | grep class`
	
install:
	mkdir -p ${DATADIR}/radare
	${INSTALL_DATA} radare.jar ${DATADIR}/radare/

clean:
	${E} 'Cleaning java'
	-${Q}rm -rf `find . | grep class` xxx

run:
	#java org.nopcode.pancake.radare.demos.Disassembler /bin/ls
	java org.nopcode.pancake.radare.demos.Find /bin/ls lib

=== libusbsniff/Makefile ===
include ../config.mk
LIBS+=${DL_LIBS}

.SUFFIXES: .c .o
.c.o:
	${E} 'Compiling $<'
	${Q}$(CC) -c $(CFLAGS) ${SHARED_CFLAGS} -o $@ $<


all: hexdump.o libfdsniff.${SHARED_EXT} libusbsniff.${SHARED_EXT}

libfdsniff.${SHARED_EXT}: hexdump.o libfdsniff.o
	-${Q}${CC} ${CFLAGS} ${LDFLAGS} ${SHARED_CFLAGS} hexdump.o libfdsniff.o ${LIBS} -o libfdsniff.${SHARED_EXT} 2>/dev/null

libusbsniff.${SHARED_EXT}: hexdump.o libusbsniff.o
##USBSNF##
	-${Q}${CC} ${CFLAGS} ${LDFLAGS} ${SHARED_CFLAGS} hexdump.o libusbsniff.o ${LIBS} -o libusbsniff.${SHARED_EXT} 2>/dev/null
##USBSNF##

clean:
	${E} 'Cleaning libusbsniff'
	-${Q}rm -f *.${SHARED_EXT} *.o a.out

mrproper:
	${E} 'Distcleaning libusbsniff'
	-${Q}rm Makefile

=== vala/Makefile ===
include ../config.mk
include ../src/objects.mk

OBJ+=$(pref ../src/,${crOBJ})

# OBJ+=../libps2fd/*.o
# OBJ+=../libps2fd/arch/i386.o
# OBJ+=../libps2fd/arch/i386-bp.o
# OBJ+=../libps2fd/arch/i386-hack.o
#OBJ+= grava/*.o

include ../src/dbg/objects.mk
#include ../objects.mk
#FOO=$(subst dbg/,,${psOBJ})
OBJ+=$(pref ../src/dbg,${psOBJ})
#OBJ+=../src/dbg/arch/${CPU}-debug.o

OBJ+=${FOO}
OBJ+=../src/dbg/*.o
OBJ+=../src/dbg/arch/${CPU}.o
OBJ+=../src/dbg/arch/${CPU}-bp.o
OBJ+=../src/dbg/arch/${CPU}-hack.o
OBJ+=../src/dbg/unix/*.o

OBJ+=../src/arch/x86/udis86/*.o
OBJ+=../src/rabin/javasm.o
OBJ+=../src/plug/io/gdb.o
OBJ+=../src/radare.o
OBJ+=../src/utils.o
OBJ+=../src/inout.o
OBJ+=../src/project.o
OBJ+=../src/config.o
OBJ+=../src/flags.o
OBJ+=../src/cons.o
OBJ+=../src/print.o
OBJ+=../src/code.o
OBJ+=../src/socket.o
OBJ+=../src/dietline.o
OBJ+=../src/plugin.o
OBJ+=../src/plug/hack/*.o
OBJ+=../src/plug/io/*.o
#OBJ+=../rasc/sysproxy.o ../rasc/syscall-linux.o ../rasc/rpc.o

CFLAGS+=-DRADARE_CORE -I.
VALAFLAGS=--save-temps
VALAFLAGS=-g

%.o:%.c
	${CC} -c `pkg-config --cflags vte gtk+-2.0` $<

#shell.o

VOBJ=config.o core.o debug.o debugger.o info.o inout.o line.o list.o logs.o plugin.o project.o radget.o term.o visor.o default_layout.o edge.o graph.o layout.o node.o renderer.o shape.o widget.o
BIN=a.out

#${CC} -lewf -g ${OBJ} ${VOBJ} -o ${BIN} `pkg-config gtk+-2.0 vte --libs`
all: all_vala ${VOBJ}

all_vala:
	@do=0; \
	for o in ${VOBJ}; do \
		v=$$(echo grava/$$o|sed -e s,o$$,vala,) ; \
		c=$$(echo $$o|sed -e s,o$$,c,) ; \
		if [ $$v -nt $$c ]; then echo "updated $$v"; do=1 ; fi ; \
	done ; \
	if [ $${do} = 1 ]; then \
	echo "Generating C files..." ; \
	valac --help > /dev/null && valac ${VALAFLAGS} -C -c --pkg vte --pkg gtk+-2.0 grava/*.vala ; \
	fi

#${CC} -lewf -g ${OBJ} *.c `pkg-config --cflags --libs gtk+-2.0 vte` -lreadline
#${CC} -lewf -g ${OBJ} *.o `pkg-config --cflags --libs gtk+-2.0 vte` -lreadline

allavas: ../src/radare.o
	#${VALAC} ${VALAFLAGS} -c --pkg vte --pkg gtk+-2.0 *.vala api/*.vala panel/*.vala
	${CC} -lewf -g ${OBJ} *.o `pkg-config --cflags --libs gtk+-2.0` `pkg-config --cflags --libs vte` -lreadline
c:
	${VALAC} ${VALAFLAGS} -c --pkg vte --pkg gtk+-2.0 *.vala api/*.vala panel/*.vala

clean:
	rm -f *.o a.out

=== src/dbg/Makefile ===
include ../../config.mk
CFLAGS+=-I../arch/ -I ../include -I/usr/local/include
include objects.mk
FOO=$(subst dbg/,,${psOBJ})
OBJ+=${FOO}
LIB=ptrace.${SHARED_EXT}
#LIBPRE=libps2fd.so

#all: ptrace.o ${OBJ}
#	${CC} ${LDFLAGS} ptrace.o ${OBJ} ${LIBS} -shared -o ${LIB}

all: ${OBJ}
	@-${Q}echo [src/dbg] debugger layer build done

#${CC} ${LDFLAGS} ${OBJ} ${LIBS} ${SHARED_CFLAGS} -o ${LIB}

clean:
	${E} '[src/dbg] Cleaning ...'
	-${Q}rm -f ptrace.o ${OBJ} ${LIB} ${LIBPRE} demo dbg/unix/*.o dbg/win32/*.o

=== src/javasm/Makefile ===
include ../../config.mk

OBJ=../rabin/javasm.o main.o
BIN=javasm${BINSFX}

all: ${BIN}
	@echo done

${BIN}: ${OBJ}
	${CC} ${LDFLAGS} ${OBJ} ${LIBS} -o ${BIN}

clean:
	-rm -f ${BIN} ${OBJ}

=== src/rabin/Makefile ===
include ../../config.mk

CFLAGS+=-DRADARE_CORE -g
OBJ=dietelf.o dietelf64.o rabin.o dietpe.o dietpe64.o dietmach0.o dietmach0_utils.o aux.o

all: rabin${BINSFX}

rabin${BINSFX}: ${OBJ}
	${CC} ${OBJ} ${DL_LIBS} -o rabin${BINSFX}

clean:
	-rm -f dietelf.o dietelf64.o rabin.o dietpe.o dietpe64.o dietmach0.o dietmach0_utils.o rabin${BINSFX} aux.o

=== src/rasc/Makefile ===
include ../../config.mk

OBJ=shellcodes.o test.o rasc.o ${SYSPROXY_OBJ}
# XXX: only for sysproxy example. to be removed
CFLAGS+=-DMKPFX=\"../\"
OBJ2=test_sp.o rpc.o syscall-linux.o sysproxy.o
BIN=rasc${BINSFX}

all: ${BIN}

${BIN}: ${OBJ}
	${E} 'Linking rasc'
	${Q}${CC} ${LDFLAGS} -o ${BIN} ${OSOLIBS} ${LIBS} ${OBJ}

${OBJ}: %.o: %.c
	${E} 'Compiling $<'
	${Q}${CC} ${CFLAGS} -c -o $@ $<

${OBJ2}: %.o: %.c
	$(E) 'Compiling $<'
	$(Q)$(CC) $(CFLAGS) -c -o $@ $<

_test_sp: ${OBJ2}
	${E} 'Linking test_sp'
	${Q}${CC} -o test_sp test_sp.o rpc.o syscall-linux.o

_rasc: ${OBJ}

test:
	${E} 'Linking test'
	${Q}${CC} -o srv test_srv1.c syscall.S -DLISTENER_TCP
	${Q}${CC} -o dump_sh dump_sh.c syscall.S -DLISTENER_TCP

clean:
	${E} 'Cleaning rasc'
	-${Q}rm -f *.o dump_sh srv test_sp rasc *.exe

=== src/rasm/Makefile ===
include ../../config.mk

OBJ=rasm.o x86.o arm.o java.o ppc.o main.o ../w32utils.o olly.o rsc.o
OLLYOBJ=../arch/x86/ollyasm/assembl.o
OLLYOBJ+=../arch/x86/ollyasm/asmserv.o
OLLYOBJ+=../arch/x86/ollyasm/disasm.o
OBJ+=${OLLYOBJ}

all: rasm${BINSFX}

rasm${BINSFX}: ${OBJ}
	${CC} ${OBJ} -o rasm${BINSFX} ../utils.c

clean:
	-rm -f ${OBJ} rasm${BINSFX}

=== src/rsc/Makefile ===
include ../../config.mk
DESTDIR?=/

FILES=add asm bdcolor bin2txt dasm elf-base-addr elf-dump-header dbg-report
FILES+=elf-entry-point elf-flag-header elf-quad-word-shell findrawsyms path
FILES+=gdl2gml make_symbolmap.sh objdiff objdump-output-beatifier.pl start2bin
FILES+=read rfile-foreach spcc syms-dump syms syms-dbg-flag maps adict monitor
FILES+=syms-flag syms-xrefs elf-trace write xtrace ffftoneg core gtkdialog
FILES+=bin2tab tab2asm tab2gml move bytediff Display net-tcp net-udp net-icmp
FILES+=strings-flag syms-pe-flag flag gokolu bin2xml search-asm strings-flag
FILES+=strings-pe-flag syscall-flag dwarf-lines dwarf-addr list syms-extract
FILES+=boomerang flag-sections elf-prg-maps flag-kallsyms spcc-fe asmcolor
FILES+=signsrch fds symdiff idc2rdb dwarf-addrs dwarf-at daemon daemon-cmd

BIN=rsc

all: main.o
	${CC} -o ${BIN} main.o

clean:
	-rm -f main.o

list:
	@for a in pool/${FILES}; do echo $$a; done

miss:
	@perl miss.pl

install:
	${INSTALL_DIR} ${DESTDIR}/${LIBDIR}
	${INSTALL_DIR} ${DESTDIR}/${LIBDIR}/radare
	${INSTALL_DIR} ${DESTDIR}/${LIBDIR}/radare/bin
	rm -rf ${DESTDIR}/${LIBDIR}/radare/bin/*
	for A in pool/* ; do cp $$A ${DESTDIR}/${LIBDIR}/radare/bin ; done
	-chmod +x ${DESTDIR}/${LIBDIR}/radare/bin/*
	#for A in ${FILES} ; do cp pool/$$A ${DESTDIR}/${DATADIR}/radare/rsc ; done

files:
	@echo ${FILES}

## radare 1.5.2

=== wscript ===
--- 
+++ 
@@ -5,7 +5,7 @@
 import shutil
 import Options
 
-VERSION='1.3'
+VERSION='1.5'
 APPNAME='radare'
 
 srcdir = '.'
@@ -218,10 +218,13 @@
 	#if Params.g_commands['clean']:
 	#	os.system("echo unknown clean")
 
-	bld.install_files('${PREFIX}/lib/python2.5', 'src/plug/hack/radare.py')
-	bld.install_files('${PREFIX}/lib/python2.6', 'src/plug/hack/radare.py')
-	bld.install_files('${PREFIX}/lib/radare', 'src/plug/hack/radare.lua')
-	bld.install_files('${PREFIX}/lib/radare', 'src/plug/hack/radare.rb')
+	bld.install_files('${PREFIX}/lib/python2.5/site-packages/radare',
+		'api/python/radare/*')
+	bld.install_files('${PREFIX}/lib/python2.6/site-packages/radare',
+		'api/python/radare/*')
+	bld.install_files('${PREFIX}/lib/radare/lua', 'api/lua/radare/*')
+	bld.install_files('${PREFIX}/lib/ruby/1.8/radare',
+		'api/ruby/radare/*')
 	# RSC scripts
 	#if bld.env['HAVE_RUBY'] == 1:
 	try:

=== api/Makefile ===
include ../config.mk

all:
	@echo Nothing to do

install:
	# ruby
	-mkdir -p ${DESTDIR}${LIBDIR}/ruby/1.8
	-cp -rf ruby/radare ${DESTDIR}${LIBDIR}/ruby/1.8
	# python
	-mkdir -p ${DESTDIR}${LIBDIR}/python2.5/site-packages
	-mkdir -p ${DESTDIR}${LIBDIR}/python2.6/site-packages
	-cp -rf python/radare ${DESTDIR}${LIBDIR}/python2.5/site-packages
	-cp -rf python/radare ${DESTDIR}${LIBDIR}/python2.6/site-packages
	# XXX lua
	-cp -rf lua/radare/api.lua ${DESTDIR}${LIBDIR}/radare/radare.lua

.PHONY: all install

=== doc/Makefile ===
all:
	halibut --pdf=radare.pdf radare.but
	halibut --text=radare.pdf.txt radare.but > /dev/null 2>&1
	halibut --html=radare.pdf.html radare.but
	mkdir -p html && cd html && halibut --html ../radare.but

push:
	scp radare.pdf radare.pdf.html radare.org:/srv/http/radareorg/get
	rsync -avz html/* radare.org:/srv/http//radareorg/doc/html

=== gui/Makefile ===
include ../config.mk

BIN=gradare${BINSFX}
OBJ=main.o topbar.o toolbar.o actions.o execute.o prefs.o menubar.o dialog.o
CFLAGS+=-DPREFIX=\"${PREFIX}\" -DGRSCDIR=\"${DATADIR}/radare/gradare\"
CFLAGS+=${GTK_FLAGS} ${VTE_FLAGS}
#`pkg-config glib-2.0 gtk+-2.0 vte --cflags`
LIBS+=${GTK_LIBS} ${VTE_LIBS}
CFLAGS+=-D_MAEMO_=${MAEMO}
#`pkg-config glib-2.0 gtk+-2.0 vte --libs`
# MAEMO STUFF
ifeq ($(MAEMO),1)
CFLAGS+=`pkg-config --cflags hildon-1`
LIBS+=`pkg-config --libs hildon-1`
endif


all: ${BIN}
	@echo 'Linking ${BIN}'

${BIN}: ${OBJ}
	${CC} ${CFLAGS} ${LDFLAGS} ${OBJ} ${LIBS} -o ${BIN}

${OBJ}: %.o: %.c
	@echo 'Compiling $<'
	${CC} ${CFLAGS} -c -o $@ $<

install:
	@echo 'Installing gradare'
	${INSTALL_DIR} ${DESTDIR}/${PREFIX}/bin
	-${INSTALL_PROGRAM} ${BIN} ${DESTDIR}/${PREFIX}/bin
	-rm -rf ${DESTDIR}/${DATADIR}/radare/gradare/*
	mkdir -p ${DESTDIR}/${DATADIR}/radare/gradare/
	cp -rf grsc/* ${DESTDIR}/${DATADIR}/radare/gradare/
	-chmod +x ${DESTDIR}/${DATADIR}/radare/gradare/Shell

clean:
	@echo 'Cleaning gui'
	-rm -f ${OBJ} ${BIN}

=== java/Makefile ===
include ../config.mk

all:
	@echo 'Compiling java code'
	${JAVAC} org/nopcode/pancake/radare/*.java
	${JAVAC} org/nopcode/pancake/radare/data/*.java
	${JAVAC} org/nopcode/pancake/radare/demos/*.java
	${JAVAC} org/nopcode/pancake/radare/swing/*.java

jar:
	if [ ! -e org/nopcode/pancake/radare/Radare.class ]; then\
		echo "Java api not compiled.";\
		exit 1;\
	fi
	jar cmf ./META-INF/MANIFEST.MF ./radare.jar `find org | grep class`
	
install:
	mkdir -p ${DATADIR}/radare
	${INSTALL_DATA} radare.jar ${DATADIR}/radare/

clean:
	@echo 'Cleaning java'
	-rm -rf `find . | grep class` xxx

run:
	#java org.nopcode.pancake.radare.demos.Disassembler /bin/ls
	java org.nopcode.pancake.radare.demos.Find /bin/ls lib

=== libusbsniff/Makefile ===
include ../config.mk
LIBS+=${DL_LIBS}

.SUFFIXES: .c .o
.c.o:
	@echo 'Compiling $<'
	$(CC) -c $(CFLAGS) ${SHARED_CFLAGS} -o $@ $<


all: hexdump.o libfdsniff.${SHARED_EXT} libusbsniff.${SHARED_EXT} libioctlsniff.${SHARED_EXT}

libfdsniff.${SHARED_EXT}: hexdump.o libfdsniff.o
	-${CC} ${CFLAGS} ${LDFLAGS} ${SHARED_CFLAGS} hexdump.o libfdsniff.o ${LIBS} -o libfdsniff.${SHARED_EXT} 2>/dev/null

libioctlsniff.${SHARED_EXT}: hexdump.o libioctlsniff.o
	-${CC} ${CFLAGS} ${LDFLAGS} ${SHARED_CFLAGS} hexdump.o libioctlsniff.o ${LIBS} -o libioctlsniff.${SHARED_EXT} 2>/dev/null

libusbsniff.${SHARED_EXT}: hexdump.o libusbsniff.o
##USBSNF##
	-${CC} ${CFLAGS} ${LDFLAGS} ${SHARED_CFLAGS} hexdump.o libusbsniff.o ${LIBS} -o libusbsniff.${SHARED_EXT} 2>/dev/null
##USBSNF##

clean:
	@echo 'Cleaning libusbsniff'
	-rm -f *.${SHARED_EXT} *.o a.out

=== sql/Makefile ===
all:
	sqlite3 test.rdb < init.sql

read:
	sqlite3 test.rdb "select * from t1;"

=== tests/Makefile ===
all:
	@-for a in chk/*.sh ; do \
		sh $$a ; \
	done
#	@-for a in chk/*.lua ; do \
#		radare -i $$a malloc://10; \
#	done

=== vala/Makefile ===
--- 
+++ 
@@ -54,7 +54,8 @@
 BIN=a.out
 
 #${CC} -lewf -g ${OBJ} ${VOBJ} -o ${BIN} `pkg-config gtk+-2.0 vte --libs`
-all: all_vala ${VOBJ}
+#all: all_vala ${VOBJ}
+all: ${VOBJ}
 
 all_vala:
 	@do=0; \

=== api/ruby/Makefile ===
all:
	ruby server.rb

client:
	ruby client.rb

=== dist/maemo/Makefile ===
# Example custom makefile for creating .deb without using dpkg tools.
#
# Author: Tim Wegener <twegener@madabar.com>
#
# This requires deb_hand.mak

# Sources:
# SOURCE_DIR - directory containing files to be packaged
# ICON_SOURCE - 26x26 icon file for maemo
# description.txt - description with summary on first line
# preinst, postinst, prerm, postrm - optional control shell scripts

# These fields are used to build the control file.
PACKAGE = radare
VERSION = 1.1
ARCH = armel
SECTION = user/shell
PRIORITY = optional
MAINTAINER = pancake <pancake@youterm.com>
# todo: For python2.4 it also needs python2.4-elementtree and python2.4-sqlite
DEPENDS =
# todo: Recommends
PACKAGE_DIR=${PWD}

#SOURCE_DIR = .
ICON_SOURCE =
#ICON_SOURCE =${SOURCE_DIR}/maemo_deb/exaile26.png
PRG=../../build/default/
PRG=../../
SPRG=../../


${PACKAGE_DIR}/data: ${SOURCE_DIR}
	rm -rf $@
	mkdir $@
	mkdir -p $@/usr/bin $@/usr/share/doc/radare $@/usr/share/radare/ $@/usr/libexec/gradare $@/usr/share/radare/rsc $@/usr/lib $@/usr/share/radare/magic
	#radare
	-cp ${PRG}/src/radiff/radiff $@/usr/bin/radiff
	#-cp ${PRG}/src/rsc/pool/bindiff $@/usr/bin/bindiff
	-cp ${PRG}/src/radare $@/usr/bin/radare
	-cp ${PRG}/src/rabin/rabin $@/usr/bin/rabin
	-cp ${PRG}/src/rasm/rasm $@/usr/bin/rasm
	-cp ${PRG}/src/rasc/rasc $@/usr/bin/rasc
	-cp ${PRG}/src/arch/arm/aasm/armasm $@/usr/bin/armasm
	-cp ${PRG}/src/rsc/rsc $@/usr/bin/rsc
	-cp ${PRG}/src/rfile $@/usr/bin/rfile
	-cp ${PRG}/src/rahash/rahash $@/usr/bin/rahash
	-cp ${PRG}/src/rax $@/usr/bin/rax
	-cp ${PRG}/src/xrefs $@/usr/bin/xrefs
	-cp ${PRG}/src/javasm/javasm $@/usr/bin/javasm
	-cp ${PRG}/gui/gradare $@/usr/bin/gradare
	-cp /usr/bin/gtkdialog $@/usr/bin/gtkdialog
	#-cp /usr/lib/libvte.so.4 $@/usr/lib
	mkdir -p $@/usr/share/radare/gradare
	-cp -rf ${SPRG}/gui/grsc/* $@/usr/share/radare/gradare
	-cp -rf ${SPRG}/src/rsc/pool/* $@/usr/share/radare/rsc
	-cp -rf ${SPRG}/magic/* $@/usr/share/radare/magic/
	-cp -rf ${SPRG}/doc/* $@/usr/share/doc/radare/
	-chmod +x $@/usr/bin/*
	mkdir -p $@/usr/share/applications/hildon/
	-cp ${SPRG}/gui/gradare.desktop $@/usr/share/applications/hildon/

include deb_hand.mak

=== scripts/inject/Makefile ===
all:
	as shellcode.s
	ld shellcode.o -o shellcode
	radare -i dump-text.lua shellcode #> shellcode.text

=== debian/changelog ===
radare (1:1.5.2-6) unstable; urgency=low

  * fix glib includes for glib 2.32+ (Closes: #665604) 

 -- Sebastian Reichel <sre@debian.org>  Wed, 28 Mar 2012 03:05:57 +0200

radare (1:1.5.2-5) unstable; urgency=low

  * Fix spelling-error-in-description: extracter -> extractor 
  * Update Debian Standards Version to 3.9.3 
  * Update vala build dependency to 0.14 (Closes: #663298)

 -- Sebastian Reichel <sre@debian.org>  Sat, 17 Mar 2012 04:40:16 +0100

radare (1:1.5.2-4.1) unstable; urgency=low

  * Non-maintainer upload.
  * Bug fix: "Doesn't contain source for waf binary code", thanks to
    Gerfried Fuchs (Closes: #654497).

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 20 Jan 2012 21:38:41 +0100

radare (1:1.5.2-4) unstable; urgency=low

  [ Stefano Rivera ]
  * Add support for Python 2.7 (Closes: #629122)
    - Apply python-2.7.patch from upstream repository.
  * python-default-only.patch: Only install extensions for the current python
    default version.

  [ Sebastian Reichel ]
  * Update my mail address
  * Remove DM-Upload-Allowed flag
  * Update Debian Standards Version to 3.9.2
  * Switch from python-support to dh_python2
  * debian/rules: differ between build-arch and build-indep target

 -- Sebastian Reichel <sre@debian.org>  Sun, 03 Jul 2011 21:04:36 +0200

radare (1:1.5.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control:
    - Build-depend on libvala-0.10-dev, optionally with libvala-dev, as
      the latter has been dropped from vala package (Closes: #624429).
  * debian/pyversions:
    - Support python2.6 only.
  * debian/rules:
    - Remove files created for python2.5.

 -- Luca Falavigna <dktrkranz@debian.org>  Sun, 01 May 2011 20:15:18 +0200

radare (1:1.5.2-3) unstable; urgency=low

  * Update Debian Standards Version to 3.9.1
  * Add patch to always link against libdl,
    this fixes an FTBFS on kfreebsd and hurd
  * add Ubuntu patch to fix buffer overflow
  * add Ubuntu patch to fix building if only python2.6 is available

 -- Sebastian Reichel <elektranox@gmail.com>  Sun, 22 Aug 2010 16:55:09 +0200

radare (1:1.5.2-2) unstable; urgency=low

  * cherry pick upstream patch to fix disabled debugger.
    This should fix build on arches not supported by radare debugger.
  * Add patch improving Makefile's clean target
  * Allow DM Upload

 -- Sebastian Reichel <elektranox@gmail.com>  Mon, 05 Jul 2010 13:59:01 +0200

radare (1:1.5.2-1) unstable; urgency=low

  * New upstream release
   - drop gtkdialog (Closes: #583888, #560676)
   - lua plugin should build on all arches (Closes: #544829)
   - many upstream bug fixes (Closes: #534700)
   - bashism has been fixed upstream (Closes: #535884)
  * Build-depend on libreadline-dev (Closes: #553833)
  * byte-compile Python files (Closes: #566048)
  * Remove ruby, does not work currently
  * Add watch file for -free version (DFSG compatible source tarball)
  * Switch to DebSrc 3.0

 -- Sebastian Reichel <elektranox@gmail.com>  Tue, 29 Jun 2010 14:01:34 +0200

radare (1:1.4-1) unstable; urgency=low
 
  * New hg checkout (stable release 1.4)
   - Fix mipsel arch translation for debugger objects
   - Fix FreeBSD and NetBSD build
   - alias mips->mips64
   - Keep cons_buffer contents in radare_cmd_str
   - Install ranal API
   - Fix rsc monitor
   - improved shellcode injection
   - Fixed syscall related stuff for x86_64
   - Added cmd '=' to send cmd to remote radares
   - Install radapy API
   - Implement rap:// URI handling in remote IO plugin
   - Fixed Elf64_Xword/Elf32_word bug in dietelf
   - Fix register handling for arm-darwin (debugger finally working!)
   - Added 'armv5tejl' (armel) to the whitelist of supported debuggers
  * Use python-config for detecting python cflags and libs
   - This should fix Ubuntu build failure

 -- Sebastian Reichel <elektranox@gmail.com>  Wed, 03 Jun 2009 17:38:00 +0200

radare (20090525-1) unstable; urgency=low

  * fixed cddl.txt encoding
  * new hg checkout
   - fixups in agd and analyzing
   - python2.6 support
   - 'q' command accepts a numeric argument (exit value)
   - Fix a radare_cmd_str() problem related to cons_grep
   - Initial import of the 'ranal' api
   - pX is now a new print format (FMT_HEXPAIRS)
   - new stuff for the analysis python api
   - remove bashism (Closes: #530178)
   - change ppc_disasm license (try to get it DSFSG compliant)
   - Added graph.traces to colorize traced nodes in graphviz and grava
   - Some more random words for the book
   - Documentate the /P command in the book
   - whitelist debugger support for armelv5tel-linux (armel)
   - fix ignorance of --without-debugger flag
   - fix mipsel arch translation for debugger objects
   - fix FreeBSD build
   - mips->mips64
  * ppc disasm support stays disabled
   - ppc_disasm license is still not DFSG compliant

 -- Sebastian Reichel <elektranox@gmail.com>  Mon, 25 May 2009 01:05:00 +0200

radare (20090522-1) unstable; urgency=low

  * new hg checkout
   - added 'cX' command to compare like 'cc' does but using
     two side hexdiff dump format
   - specify pointer & data size in pm with %<size>
   - add graph.weight
   - fix 'c' command (missing radare_read(0))
   - added /P search command that searches for proximity in
     bytelevel distance
   - added more 'ag' and 'gu' commands to readline autocompletion.
   - fix build of debugger for non-linux systems
   - fixed code analysis at startup
   - more work in graphs (graph.split)
   - fixups in x86 code analysis

 -- Sebastian Reichel <elektranox@gmail.com>  Fri, 22 May 2009 19:01:00 +0200

radare (20090521-1) unstable; urgency=low

  * new hg checkout with lots of fixups
  * builds on architectures without debugger support (Closes: #529997)

 -- Sebastian Reichel <elektranox@gmail.com>  Thu, 21 May 2009 16:26:00 +0200

radare (20090519-1) unstable; urgency=low

  * switch to hg snapshots
  * uses changeset 1045 (ed3ba99d8537)
  * remove ppc disasm source (for DFSG compability)


=== debian/control ===
Source: radare
Section: devel
Priority: optional
Vcs-Git: git://git.debian.org/collab-maint/radare.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/radare.git
Maintainer: Sebastian Reichel <sre@debian.org>
Build-Depends: autotools-dev,
               debhelper (>= 7),
               halibut,
               libgtk2.0-dev,
               liblua5.1-0-dev,
               libusb-dev,
               libperl-dev,
               libreadline-dev,
               libvala-0.14-dev,
               libvte-dev,
               lua5.1,
               python-dev (>= 2.6.6-3~),
               valac-0.14
Standards-Version: 3.9.3
Homepage: http://radare.org

Package: radare
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, radare-common
Conflicts: radare-gtk
Description: free advanced command line hexadecimal editor
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped
 IO layer supporting multiple backends for local/remote files,
 debugger (osx,bsd,linux,w32), stream analyzer, assembler/disassembler
 (rasm) for x86,arm,ppc,m68k,java,msil,sparc code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting (pe, mach0, elf, class, ...) named rabin, and a block-based
 hash utility called rahash.
 .
 This package contains the non gtk version of radare. You won't be able
 to use the ag command for drawing graphs and gradare is missing.

Package: radare-gtk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, radare-common
Conflicts: radare
Description: free advanced command line hexadecimal editor with graph functionality
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped
 IO layer supporting multiple backends for local/remote files,
 debugger (osx,bsd,linux,w32), stream analyzer, assembler/disassembler
 (rasm) for x86,arm,ppc,m68k,java,msil,sparc code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting (pe, mach0, elf, class, ...) named rabin, and a block-based
 hash utility called rahash.
 .
 This package contains the gtk enabled edition of radare.

Package: radare-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Description: utilities and scripts used by radare
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped
 IO layer supporting multiple backends for local/remote files,
 debugger (osx,bsd,linux,w32), stream analyzer, assembler/disassembler
 (rasm) for x86,arm,ppc,m68k,java,msil,sparc code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting (pe, mach0, elf, class, ...) named rabin, and a block-based
 hash utility called rahash.
 .
 This package contains utilities and scripts used by the terminal and
 gtk edition of radare.

Package: radare-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: documentary for radare
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped
 IO layer supporting multiple backends for local/remote files,
 debugger (osx,bsd,linux,w32), stream analyzer, assembler/disassembler
 (rasm) for x86,arm,ppc,m68k,java,msil,sparc code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting (pe, mach0, elf, class, ...) named rabin, and a block-based
 hash utility called rahash.
 .
 This package contains the radare book and some additional docs.

=== debian/rules ===
#!/usr/bin/make -f

# This has to be exported to make some magic below work.
export DH_OPTIONS

build: build-stamp
build-stamp: build-arch build-indep
	touch build-stamp
build-arch: build-nongtk build-gtk
build-indep: build-doc

build-nongtk:
	dh_testdir

	[ ! -f Makefile ] || $(MAKE) clean

	# radare non gtk edition
	./configure --prefix=/usr --includedir=/usr/include \
	--mandir=/usr/share/man --sysconfdir=/etc \
	--libexecdir=/usr/lib --without-gui --without-nonfree

	$(MAKE)

	# get non gtk radare binary
	cp src/radare radare

build-gtk:
	dh_testdir

	[ ! -f Makefile ] || $(MAKE) clean

	# radare gtk edition
	./configure --prefix=/usr --includedir=/usr/include \
	--mandir=/usr/share/man --sysconfdir=/etc \
	--libexecdir=/usr/lib --without-nonfree

	$(MAKE)

build-doc:
	# build documentary (radare book)
	cd doc && $(MAKE) && cd ..

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# clean up build process
	[ ! -f Makefile ] || $(MAKE) clean
	rm -f radare
	dh_clean

install: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

binary-common:
	dh_testdir
	dh_testroot
	dh_install
	dh_installdocs
	dh_installmenu
	dh_installman
	dh_installchangelogs
	dh_python2 -V $(shell pyversions -vd)
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep: build-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

binary-arch: build-arch install
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
http://radare.org/get/radare-([0-9\.]*)-free\.tar\.gz
